#ifndef DOWNLOADER_GUI_H
#define DOWNLOADER_GUI_H

#include "IFFWDMInterfaces.h"

class DownloaderGUI : public UI_Manager
{
public:
	virtual void ShowNextButton(bool doShow);
	virtual void ShowPreviousButton(bool doShow);
	virtual void ShowProgressBar(bool doShow);
	virtual void ShowInputText( bool doShow);
	virtual void ShowMultiButton( bool doShow );
	virtual void IdleProgressBar(long curPos);
	virtual void SetProgressBarMax(long maxPos);
	virtual void InvalidateDialog(void);
	virtual void SetNextButtonTitle(const char *pNewTitle);
	virtual void SetPreviousButtonTitle(const char *pNewTitle);
	virtual void SetMultiButtonTitle(const char *pNewTitle);
	virtual void SetMessage(const char *pNewTitle, bool doInval = false);
	virtual void SetInputMessage(const char *pNewTitle);
	virtual void MessageBox(const char *pNewTitle);
	virtual void Exit(void);
	virtual int OpenDownloadFileDialog(void);
	virtual int OpenOSFile(void);	
	virtual void LockExitMenu(bool doLock);
private:
	bool m_ExitLocked;
};

ControlRef GetMacControlRefByID(long id);

#endif
