#pragma once


////////////////////////////////////////////////////////////////////
// DLL Export / Import Macros
#if !defined(PUBLIC_CORE)
	#define PUBLIC_CORE     
#endif



typedef char 				int8;
typedef unsigned char 		uint8;
typedef short 				int16;
typedef unsigned short 		uint16;
typedef long 				int32;
typedef unsigned long 		uint32;

typedef unsigned char 		uchar;
typedef unsigned short 		ushort;
typedef unsigned long 		ulong;
typedef unsigned char		boolean;

//typedef uint32				XTimeStamp;
// JI: 01/21/2004 changed this to double..
typedef double				XTimeStamp;

typedef long				XErr;
typedef long				XResult;
typedef long				XPortID;

typedef double				xfloat;

#ifndef WIN32
typedef uint32				DWORD;
typedef ushort				WORD;
#define CALLBACK	
#endif

#ifdef WIN32
#define COMPILER_HAS_INT64
typedef unsigned __int64  uint64;
typedef __int64 int64;
#endif

#ifdef BEOS
#define COMPILER_HAS_INT64
#endif

#ifdef MAC
#define COMPILER_HAS_INT64
typedef long long int64;
typedef long long uint64;
#endif



#ifndef COMPILER_HAS_INT64
class PUBLIC_CORE uint64
{
public:
	uint64(uint32 _hi = 0, uint32 _lo = 0) : hi(_hi), lo(_lo) {}

    uint64 & operator=(const uint32 value) { hi = 0; lo = value; return *this; }
    uint64 & operator=(const uint64 &source) { hi = source.hi; lo = source.lo; return *this; }

	uint32	hi;
	uint32	lo;
} ;
#endif


#ifndef COMPILER_HAS_INT64
class PUBLIC_CORE int64
{
public:
	int64(void) : hi(0), lo(0) {}
	int64(int32 _hi, uint32 _lo) : hi(_hi), lo(_lo) {}

	int32	hi;
	uint32	lo;

	int64 &operator=(const int64 &rhs) { hi = rhs.hi; lo = rhs.lo; return *this; }
	int64 &operator=(const uint64 &rhs) { hi = rhs.hi; lo = rhs.lo; return *this; }

	int64 & operator=(const int32 value) { hi = 0; lo = value; return *this; }
	operator uint64(void) { return uint64((uint32)hi, lo); }
};
#endif

#define xmax(a,b)            (((a) > (b)) ? (a) : (b))
#define xmin(a,b)            (((a) < (b)) ? (a) : (b))
#define xabs(a)            	 (((a) < (0)) ? (-a) : (a))

