#ifndef XERR_H
#define XERR_H

#ifndef KERNEL_CODE
#include "XTypes.h"
#endif

// NOTE: that XErr is a long now
//typedef long	XErr;

#define NOERR	             0
#define MAKE_ERROR(x)       (0x80000000|(x))			// This creates a negative number  - so return codes >= 0 are no error

// jj - Add more defines as are needed...

#define ERR_FAIL				MAKE_ERROR(1)
#define ERR_POINTER				MAKE_ERROR(2)
#define ERR_INVALIDARG			MAKE_ERROR(3)
#define ERR_TIMEOUT				MAKE_ERROR(4)
#define ERR_FILE_NOT_FOUND		MAKE_ERROR(5)
#define ERR_FILE_OPEN			MAKE_ERROR(6)
#define ERR_FILE_READ			MAKE_ERROR(7)
#define ERR_FILE_WRITE			MAKE_ERROR(8)
#define ERR_FILE_SEEK			MAKE_ERROR(9)
#define ERR_INVAL_VERSION		MAKE_ERROR(10)

#define ERR_BURN_BAD_JOLIET_DISC	MAKE_ERROR(11)
#define ERR_BURN_MEDIA_NO_MEDIA		MAKE_ERROR(12)
#define ERR_BURN_MEDIA_UNUSABLE		MAKE_ERROR(13)
#define ERR_BURN_MEDIA_USED_CDRW	MAKE_ERROR(14)
#define ERR_BURN_NO_BURNER_FOUND	MAKE_ERROR(15)
#define ERR_BURN_FILE_NOT_STEREO	MAKE_ERROR(16)
#define ERR_BURN_FILE_NOT_44KHZ		MAKE_ERROR(17)


// JJ - If you want to define your Errors local
// to your Module you can simply define a non used range
// here (in groups of 100) maybe
#define AUDIO_ERRORS_START		100


// We need some FatalError function
void XFatal(char * errMsg);



#endif //XERR_H

