#ifndef XPLATFORM_H
#define XPLATFORM_H


// We Must include Math.h in one place since we need to turn on their defines...include this file if you need math.h
#ifndef _USE_MATH_DEFINES
//MUST DEFINE THIS IN PREPROCESSOR DEFS for some reason in 6.0
#endif

#include <math.h>


////////////////////////////////////////////////////////////////////
// DLL Export / Import Macros
#if defined(WIN32)

	#ifdef _STATIC_CORE
		#define PUBLIC_CORE		
	#elif defined(_EXPORTING_CORE)
		#define PUBLIC_CORE		__declspec( dllexport )
	#else
		#define PUBLIC_CORE		__declspec( dllimport )
	#endif

	#pragma warning ( disable : 4251 )		// turn off the dllexport warning of hidden members

#elif defined (MAC)

	#define PUBLIC_CORE     

#endif
////////////////////////////////////////////////////////////////////



#ifndef M_PI // BT: visual 6 does not define M_PI
#define M_PI 3.14159265 // found this online 
#endif

#if defined(WIN32)
	////////////////////////////////////////////////////////////////
	#if !defined(WIN)
		#define WIN
	#endif // !defined(WIN)

	#if !defined(_WINDOWS)
		#define _WINDOWS
	#endif // !defined(_WINDOWS)

	#if !defined(_WIN32_WINNT)
		// We only support Win2k and above
		#define _WIN32_WINNT 0x0501
	#endif // !defined(_WIN32_WINNT)

	#if !defined(_WIN32_DCOM)
		#define _WIN32_DCOM
	#endif // !defined(_WIN32_DCOM)

	// _DEBUG is automatically defined by Visual C++ when using debug libraries
	#if defined(_DEBUG)
		#if !defined(DEBUG)
			#define DEBUG
		#endif // !defined(DEBUG)
	#else // defined(_DEBUG)
		#if !defined(NDEBUG)
			#define NDEBUG
		#endif // !defined(NDEBUG)
	#endif // defined(_DEBUG)

	#ifdef NDEBUG
		#ifndef RELEASE
			#define RELEASE
		#endif
	#endif

	#define false   0
	#define true    1
	#define FALSE   0
	#define TRUE    1
	#define WIN32FILE
	#include <Windows.h>
	#include <stdexcept>				// exception handling support
	typedef HANDLE 	MFileRef;

	// Added this pragma to eliminate annoying warning messages.
	// The messages we're ignoring are:
	// C4018: 'expression' : signed/unsigned mismatch
	// C4244: 'conversion' conversion from 'type1' to 'type2', possible loss of data
	// C4305: 'identifier' : truncation from 'type1' to 'type2'
	// C4309: 'conversion' : truncation of constant value
	#pragma warning ( disable : 4018 4244 4305 4309 )
	////////////////////////////////////////////////////////////////

#elif defined (SMX)
	////////////////////////////////////////////////////////////////
	#include "smx.h"
	#include "unwin32.h"
	#define true 1
	#define false 0
	#define TRUE 1
	#define FALSE 0
	#ifndef CF
	typedef int 	MFileRef;
	#else
	typedef long	MFileRef;
	#endif
	////////////////////////////////////////////////////////////////

#elif defined (MAC)
	////////////////////////////////////////////////////////////////
	#define MACPPC
	#define PPC
// Mach-O does not need this
//	#include <Threads.h>
	typedef short 	MFileRef;
	////////////////////////////////////////////////////////////////

#elif defined (QNX)
	////////////////////////////////////////////////////////////////
	#include <stdio.h>
	#define true 1
	#define false 0
	#define TRUE 1
	#define FALSE 0
	typedef int 	MFileRef;
	////////////////////////////////////////////////////////////////

#elif defined (BEOS)
	////////////////////////////////////////////////////////////////
	#undef MIN
	#undef MAX
	#include <File.h>
	#define true 1
	#define false 0
	#define TRUE 1
	#define FALSE 0
	typedef BFile *MFileRef;
	////////////////////////////////////////////////////////////////

#endif
#endif  // XPLATFORM_H
